;**********************************************************
; Alarm pro ochranu dve
;**********************************************************
; Po zapnut alarmu program rozsvt a zhasne indikan LED.
; Pak otestuje stav dvenho kontaktu
; je-li sepnut (dvee zaveny) mikrokontrolr ek a se
; dvee otevou. Po jejich optovnm zaven se aktivuje 
; alarm. Dojde-li k rozepnut kontakt (oteven dve)
; a nen-li mikrokontrolr vypnut do 32 sec, zane poplach,
; kter trv 32 sec. Po tto dob je opt testovn stav dve.
; Jsou -li stle oteven, pok se 32 sec a znovu se 
; aktivuje alarm na 32 sec.
; Pokud dojde k uzaven dve, obvod pejde do stavu ostrahy
; a testuje kadch 17 ms stav dvenho kontaktu a v rytmu
; piblin dvou sekund blik indikan LED.
;..........................................................
; Fosc = 116,7 kHz (C = 330 R = 51k)
;**********************************************************
; Definice symbol
;**********************************************************
w	equ	0
f	equ	1
TMR0	equ	01h
SWR	equ	03h
PortA	equ	05h
PortB	equ	06h
;**********************************************************
rCek0	equ	10h
rCek1	equ	11h
rCek2	equ	12h
rCtInd	equ	13h
;**********************************************************
#define	C	SWR,0 
#define	DC	SWR,1 
#define	Z	SWR,2 
#define	PD	SWR,3 
#define	NTO	SWR,4 
;**********************************************************
#define	IDvere	PortA,1		;dven kontakt (oteveno=L) 
#define	OAlarm	PortB,4 	;sirna (alarm=H)
#define	NLed	PortB,3 	;indikan LED (svit=L)
;**********************************************************
	org	1ffh
	goto	start
	org	000h
	goto	start
;**********************************************************
; Vlastn program 
;**********************************************************
; Program po aktivaci pejde do reimu sleep
; kadch 17 ms dojde k probuzen, je otestovn vstup
; dvenho kontaktu. Kad 256. probuzen je indikovno
; bliknutm indikan LED.
;**********************************************************
; Podprogramy
;**********************************************************
cek32s	movlw	10h		;ekej 32 sec
	movwf	rCek2
ck32s	call	cek2s
	decfsz	rCek2,f
	goto	ck32s
	retlw	00h	
;...............................
cek2s	movlw	38h		;ekej 2 sec
	movwf	rCek1
ck2s	call	cek35ms
	decfsz	rCek1,f
	goto	ck2s
	retlw	00h	
;...............................
cek35ms	clrf	rCek0		;ekej 35.17 ms
	goto	ck12ms
;...............................
cek12ms	movlw	57h		;ekej 12 ms
	movwf	rCek0
ck12ms	clrwdt
	decfsz	rCek0,f
	goto	ck12ms
	retlw	00h
;**********************************************************
;**********************************************************
start	btfss	PD
	goto	testIO		;probuzen ze SLEEP
;*******************************
; Zapnut napjen
;*******************************
	bsf	NLed		;zhasni LED
	bcf	OAlarm		;vypni sirnu
	movlw	02h		;inicializace vstup
	tris	PortA
	movlw	00h
	tris	PortB
	movlw	00h		;TMR0 +prescaler
	option
	clrf	rCtInd
;..........................................................
	bcf	NLed		;rozsvi indikan LED
	call	cek2s
	bsf	NLed		;zhasni ndikan LED
	call	cek2s
;..........................................................
close	btfss	IDvere		;ekej na oteven dve
	goto	open		
	clrwdt
	call	cek12ms		;ekej 12 ms
	goto	close	
;...............................
open	btfsc	IDvere		;ekej na zaven dve
	goto	ostrah
	clrwdt
	call	cek12ms
	goto	open
;...............................
ostrah	bsf	OAlarm		;krtce ppni pro potvrzen
	call	cek35ms		;zasteen
	bcf	OAlarm
;...............................
secure	sleep
;*******************************
; Probuzen ze sleep
;*******************************
testIO	movlw	02h		;inicializace vstup
	tris	PortA
	movlw	00h
	tris	PortB
;................................
	btfss	IDvere		;test dvenho kontaktu
	goto	alarm		;jsou-li dvee oteveny-alarm
	incf	rCtInd,f	;inkrementace potu probuzen
	bz	onled	
	goto	secure		;ve v podku, usni
;..........................................................
onled	movlw	08h		;kad 256. probuzen
	xorwf	PortB,f		;pepni LED
	goto	secure	
;..........................................................
alarm	call	cek12ms
	btfsc	IDvere
	goto	testIO		;nelo o poplach ale o ruen
	call	cek32s		;pokej 24 sec
	bsf	NLed		;zhasni indikan LED
	bsf	OAlarm		;vyvolej poplach 24 sec
	call	cek32s
	bcf	OAlarm
	goto	testIO
;**********************************************************
	end



